import { LanguageSupport, LRLanguage } from "@codemirror/language";
declare const callIdentifiers: Set<string | undefined>;
declare const conditionIdentifiers: Set<string | undefined>;
type Position = {
    from: number;
    to: number;
};
type KarolError = {
    kind: "error";
    msg: string;
    pos: Position;
};
type CompilationResult = {
    kind: "success";
    result: GeneratorFunction;
} | KarolError;
type DefinitionCompilationResult = {
    kind: "success";
    result: string;
    identifier: string;
} | KarolError;
type InnerCompilationResult = {
    kind: "success";
    result: string;
} | KarolError;
type ExecutionResult = {
    kind: "success";
} | KarolError;
declare const karolLanguage: LRLanguage;
declare function karol(): LanguageSupport;
declare function parse(str: string): import("@lezer/common").Tree;
declare function compile(str: string): CompilationResult;
export { karolLanguage, karol, parse, compile, callIdentifiers, conditionIdentifiers, Position, KarolError, CompilationResult, DefinitionCompilationResult, InnerCompilationResult, ExecutionResult };
